︠3ce7b576-a0fb-442d-acfa-d1b4a13520c1i︠
%html
<p><span style="font-size: small;">Le TP d'aujourd'hui portera sur l'arithm&eacute;tique. On va notamment faire des calculs sur Z/nZ. De m&ecirc;me que la semaine derni&egrave;re il ne fallait pas confondre l'objet math&eacute;matique (ensemble) et sa repr&eacute;sentation informatique (liste), il faudra prendre garde cette semaine que les entiers peuvent r&eacute;pr&eacute;senter un entier math&eacute;matique ou bien un &eacute;l&eacute;ment de Z/nZ (une classe), suivant le contexte. </span></p>
<p><span style="font-size: small;">Si par exemple n=5 et qu'on veut tester l'&eacute;galit&eacute; entre 2 et 7, &eacute;crire 2==7 peut &ecirc;tre la r&eacute;ponse... ou pas.</span></p>

<p><span style="font-size: small;">Exercice 1 : &Eacute;crivez  une fonction DivEucl(a,b) qui renvoie le quotient et le reste de la  division euclidienne de a par b (entiers), en n'utilisant que la  soustraction (avec if, for et while, bien s&ucirc;r).</span></p>

︡ff7cdedf-bf1e-4895-83df-d337b2e0e5f4︡{"html": "<p><span style=\"font-size: small;\">Le TP d'aujourd'hui portera sur l'arithm&eacute;tique. On va notamment faire des calculs sur Z/nZ. De m&ecirc;me que la semaine derni&egrave;re il ne fallait pas confondre l'objet math&eacute;matique (ensemble) et sa repr&eacute;sentation informatique (liste), il faudra prendre garde cette semaine que les entiers peuvent r&eacute;pr&eacute;senter un entier math&eacute;matique ou bien un &eacute;l&eacute;ment de Z/nZ (une classe), suivant le contexte. </span></p>\n<p><span style=\"font-size: small;\">Si par exemple n=5 et qu'on veut tester l'&eacute;galit&eacute; entre 2 et 7, &eacute;crire 2==7 peut &ecirc;tre la r&eacute;ponse... ou pas.</span></p>\n\n<p><span style=\"font-size: small;\">Exercice 1 : &Eacute;crivez  une fonction DivEucl(a,b) qui renvoie le quotient et le reste de la  division euclidienne de a par b (entiers), en n'utilisant que la  soustraction (avec if, for et while, bien s&ucirc;r).</span></p>"}︡
︠ef61660c-84f3-4e1d-baf7-c20d00b7da24︠
def DivEucl(a,b):
    q = 0
    r = a
    while r>=b:
        q+=1
        r-=b
    return (q,r)
︡e6154907-fda8-442a-ba99-78af45e5e4bc︡︡
︠63bb9e5e-d6ec-443f-8127-cea9b03d5bd9i︠
%html
<p><span style="font-size: small;">Exercice 2 : Programmez l'algorithme d'Euclide en utilisant l'exercice 1. On  rappelle que l'algorithme se d&eacute;roule de la mani&egrave;re suivante :</span></p>
<p><span style="font-size: small;">- On divise a par b, obtenant q et r ;</span></p>
<p><span style="font-size: small;">- on divise b par r, obtenant q' et r'</span></p>
<p><span style="font-size: small;">- et ainsi de suite. Le r&eacute;sultat renvoy&eacute; correspond au dernier reste non nul.</span></p>

︡e9245e79-5018-4e28-bb67-76f0f23bdba9︡{"html": "<p><span style=\"font-size: small;\">Exercice 2 : Programmez l'algorithme d'Euclide en utilisant l'exercice 1. On  rappelle que l'algorithme se d&eacute;roule de la mani&egrave;re suivante :</span></p>\n<p><span style=\"font-size: small;\">- On divise a par b, obtenant q et r ;</span></p>\n<p><span style=\"font-size: small;\">- on divise b par r, obtenant q' et r'</span></p>\n<p><span style=\"font-size: small;\">- et ainsi de suite. Le r&eacute;sultat renvoy&eacute; correspond au dernier reste non nul.</span></p>"}︡
︠14fe9544-a4ab-49e7-b847-9b1645098a33︠
Euclide(26,39)
︡6f745564-74a0-450d-be35-28d1f0460ec7︡{"stdout": "13"}︡
︠573aa3cc-5c30-48d1-9f3c-690c08ce5a75i︠
%html
<p><span style="font-size: small;">Exercice 3  : Gr&acirc;ce &agrave; l'exercice 1, &eacute;crivez une fonction qui &agrave; un entier associe  l'&eacute;l&eacute;ment de sa classe compris entre 0 et n-1. Puis, &eacute;crivez des  fonctions qui testent l'&eacute;galit&eacute; et qui effectuent l'addition et la  multiplication dans Z/nZ.</span></p>

︡1cf63f70-f6fc-4dd3-9f1e-76c1986e2196︡{"html": "<p><span style=\"font-size: small;\">Exercice 3  : Gr&acirc;ce &agrave; l'exercice 1, &eacute;crivez une fonction qui &agrave; un entier associe  l'&eacute;l&eacute;ment de sa classe compris entre 0 et n-1. Puis, &eacute;crivez des  fonctions qui testent l'&eacute;galit&eacute; et qui effectuent l'addition et la  multiplication dans Z/nZ.</span></p>"}︡
︠fa759179-541b-41c3-a0f6-39ec8b2c98d5︠
def Classe(a,n):
    q,r = DivEucl(a,n)
    return r                                 # En fait, on peut aussi écrire a%n, mais je voulais utiliser l'exercice 1.
    
def Egalite(a,b,n):
    return (a%n == b%n)

def Addition (a,b,n):
    return (a+b)%n
    
def Multiplication (a,b,n):
    return (a*b)%n
︡c7bb69a9-9bce-46a0-a26c-05e26f8ea61d︡︡
︠bb225943-db9c-4d9a-a38f-37ea76511b9ai︠
%html
<p><span style="font-size: small;">En d&eacute;duire une fonction Divise(a,b,n) qui teste si a divise b dans Z/nZ </span><span style="font-size: small;">(il existe k tel que ka=b).</span></p>

︡94d7476c-5179-4423-965c-aa0f3152e568︡{"html": "<p><span style=\"font-size: small;\">En d&eacute;duire une fonction Divise(a,b,n) qui teste si a divise b dans Z/nZ </span><span style=\"font-size: small;\">(il existe k tel que ka=b).</span></p>"}︡
︠112c53ab-0e1d-404d-94f0-ecb433187b33︠
def Divise (a,b,n):
    for k in range(n):
        if Egalite(k*a,b,n): return True
    return False
︡cc28d877-2c35-47ed-b73f-6cc2690136c2︡︡
︠616a35ce-7106-4c03-93fc-4ea28409a597i︠
%html
<p><span style="font-size: small;">Vous avez appris qu'un &eacute;l&eacute;ment de Z/nZ est soit inversible (i.e. diviseur de 1), soit diviseur de z&eacute;ro. En vous inspirant de la question pr&eacute;c&eacute;dente, &eacute;crivez une fonction Diviseur(a,n) qui indique dans quel cas on est et qui renvoie un &eacute;l&eacute;ment k de Z/nZ tel que ka = 0 ou 1, suivant le cas (k non nul, bien sur). <br /></span></p>

︡19ebaaa1-58e4-476f-82bc-73fc28c1bec2︡{"html": "<p><span style=\"font-size: small;\">Vous avez appris qu'un &eacute;l&eacute;ment de Z/nZ est soit inversible (i.e. diviseur de 1), soit diviseur de z&eacute;ro. En vous inspirant de la question pr&eacute;c&eacute;dente, &eacute;crivez une fonction Diviseur(a,n) qui indique dans quel cas on est et qui renvoie un &eacute;l&eacute;ment k de Z/nZ tel que ka = 0 ou 1, suivant le cas (k non nul, bien sur). <br /></span></p>"}︡
︠0040826f-d8b0-465c-9eb8-00631c3bdc9c︠
def Inversible (a,n):
    for k in range(1,n):
        if k*a%n==1: 
            return (1,k)
        elif k*a%n==0: 
            return (0,k)
    print "Les mathématiques sont incohérentes"
︡458d904b-f400-44b9-94fd-4019807a5bf7︡︡
︠09efbbe5-bdd3-4eef-b9ab-20402bd032e0i︠
%html
<p><span style="font-size: small;">Exercice 4 : On va repr&eacute;senter un polyn&ocirc;me de degr&eacute; 3&nbsp; aX&sup3;+bX&sup2;+cX+d comme un tuple (a,b,c,d). &Eacute;crivez une fonction Polynul(a,b,c,d,n) qui teste si </span><span style="font-size: small;">aX&sup3;+bX&sup2;+cX+d = 0</span><span style="font-size: small;"> pour toute valeur de X </span><span style="font-size: small;">(dans Z/nZ)</span><span style="font-size: small;">.&nbsp;</span></p>

︡d112405a-760b-4c72-a041-c5549eb55b74︡{"html": "<p><span style=\"font-size: small;\">Exercice 4 : On va repr&eacute;senter un polyn&ocirc;me de degr&eacute; 3&nbsp; aX&sup3;+bX&sup2;+cX+d comme un tuple (a,b,c,d). &Eacute;crivez une fonction Polynul(a,b,c,d,n) qui teste si </span><span style=\"font-size: small;\">aX&sup3;+bX&sup2;+cX+d = 0</span><span style=\"font-size: small;\"> pour toute valeur de X </span><span style=\"font-size: small;\">(dans Z/nZ)</span><span style=\"font-size: small;\">.&nbsp;</span></p>"}︡
︠2aa32744-bfc3-4cc0-83a7-9a1457dd0332︠
def Polynul(a,b,c,d,n):
    for X in range(n):
        if a*X**3+b*X**2+c*X+d%n!=0: return False
    return True
︡9a83dc3b-5d21-4e5e-a3df-6b7e02b40edb︡︡
︠ddb8ae29-156a-481c-a1d0-76ba59add0d6i︠
%html
<p><span style="font-size: small;">Exercice  5 : &Eacute;crivez  une fonction CribleErathost&egrave;ne(n) qui construit une liste  allant de 2 &agrave;  n, puis ne laisse que les nombre premiers. Pour cela : </span></p>
<p><span style="font-size: small;">- Prendre les &eacute;l&eacute;ments de la liste un par un ; </span></p>
<p><span style="font-size: small;">- Supprimer tous ses multiples de la liste (sauf lui-m&ecirc;me !) ; </span></p>
<p><span style="font-size: small;">- Prendre l'&eacute;l&eacute;ment suivant, et ainsi de suite. </span></p>
<p><span style="font-size: small;">Vous   aurez sans doute besoin de [0]*n qui construit une liste de taille n   remplie de 0. Pour faire une boucle for qui fait des sauts, consultez   l'aide de "range" (avec "range?"). Rappelez-vous le TD pr&eacute;c&eacute;dent : quand peut-on s'arr&ecirc;ter ?<br /></span></p>

︡418975a9-219f-4dc4-b426-d0fdfd165004︡{"html": "<p><span style=\"font-size: small;\">Exercice  5 : &Eacute;crivez  une fonction CribleErathost&egrave;ne(n) qui construit une liste  allant de 2 &agrave;  n, puis ne laisse que les nombre premiers. Pour cela : </span></p>\n<p><span style=\"font-size: small;\">- Prendre les &eacute;l&eacute;ments de la liste un par un ; </span></p>\n<p><span style=\"font-size: small;\">- Supprimer tous ses multiples de la liste (sauf lui-m&ecirc;me !) ; </span></p>\n<p><span style=\"font-size: small;\">- Prendre l'&eacute;l&eacute;ment suivant, et ainsi de suite. </span></p>\n<p><span style=\"font-size: small;\">Vous   aurez sans doute besoin de [0]*n qui construit une liste de taille n   remplie de 0. Pour faire une boucle for qui fait des sauts, consultez   l'aide de \"range\" (avec \"range?\"). Rappelez-vous le TD pr&eacute;c&eacute;dent : quand peut-on s'arr&ecirc;ter ?<br /></span></p>"}︡
︠3ffba424-31b4-4bf0-ba88-b04ecb4f123b︠
def Eratosthene(n):                                    # Idée générale : pour 'supprimer' un nombre, on le remplace par 0.
    liste = [0]*(n-1)
    for i in range(n-1): liste[i]=i+2                  # L'entier i est stocké dans la cellule i-2
    
    for k in range(sqrt(n)):
        if liste[k]!=0:                                # Il n'a pas été supprimé : c'est donc k+2
            for j in range(2*k+2,n-1,k+2):             # On commence à 2(k+2) (stocké en 2k+2) pour ne pas effacer le premier.
                liste[j]=0                             # Et on progresse par sauts de k+2
                
    reponse=[]
    for k in liste:                                    # Maintenant on construit la reponse en supprimant les 0
        if k!=0: reponse.append(k)
    return reponse
    
Eratosthene(54)
︡e8db777f-4ab0-4f88-986b-d720dd88905f︡{"stdout": "[2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53]"}︡
︠1aec2869-a632-4ca0-a8c2-ce7f3a5a0e37i︠
%html
<p><span style="font-size: small;">Exercice 6 : &Eacute;crire une fonction Factorisation(n) qui factorise un entier n en facteurs premiers. Utilisez la question pr&eacute;c&eacute;dente et demandez-vous comment vous feriez &agrave; la main (on ne cherche pas &agrave; &ecirc;tre efficace). Renvoyez le r&eacute;sultat sous la forme que vous pr&eacute;f&eacute;rez, par exemple une liste de couples (facteur, multiplicit&eacute;), i.e. 40 = 2&sup3;.5 -&gt; [(2,3),(5,1)]. </span></p>

︡5a3c1b08-bd3d-4548-ad16-e2b5b5522999︡{"html": "<p><span style=\"font-size: small;\">Exercice 6 : &Eacute;crire une fonction Factorisation(n) qui factorise un entier n en facteurs premiers. Utilisez la question pr&eacute;c&eacute;dente et demandez-vous comment vous feriez &agrave; la main (on ne cherche pas &agrave; &ecirc;tre efficace). Renvoyez le r&eacute;sultat sous la forme que vous pr&eacute;f&eacute;rez, par exemple une liste de couples (facteur, multiplicit&eacute;), i.e. 40 = 2&sup3;.5 -&gt; [(2,3),(5,1)]. </span></p>"}︡
︠abf10972-f92f-4cba-ad97-b5fc6b676b79︠
def Factorisation(n):
    def add_list(a,l):
        fait = False
        for k in range (len(l)):
            (x,y) = l[k]
            if a==x: 
                l[k] = (x,y+1)
                fait = True
        if not fait: l.append((a,1))
    
    nombre = n
    reponse = []
    liste = Eratosthene(n)
    k=0
    while nombre!=1 :
        if nombre%liste[k] == 0:
            add_list(liste[k],reponse)
            nombre = nombre//liste[k]
        elif liste[k]>=sqrt(nombre) :
            add_list(nombre, reponse)
            nombre=1
        else:     
            k=k+1
    return reponse
︡3b054876-2245-4807-9a3b-2ff377c7a08e︡︡
︠d15ffc56-f6d8-4701-8ae8-ee4867af58a5i︠
%html
<p><span style="font-size: small;">Exercice 7: Calculons le pgcd d'une deuxi&egrave;me fa&ccedil;on ! Gr&acirc;ce &agrave; l'exercice pr&eacute;c&eacute;dent, &eacute;crivez une fonction pgcd(a,b) qui renvoie le pgcd de a et b en regardant leurs facteurs premiers communs. Comparez le r&eacute;sultat avec Euclide(a,b).</span></p>

︡25d65d69-56db-4852-8004-cd4829a35bbb︡{"html": "<p><span style=\"font-size: small;\">Exercice 7: Calculons le pgcd d'une deuxi&egrave;me fa&ccedil;on ! Gr&acirc;ce &agrave; l'exercice pr&eacute;c&eacute;dent, &eacute;crivez une fonction pgcd(a,b) qui renvoie le pgcd de a et b en regardant leurs facteurs premiers communs. Comparez le r&eacute;sultat avec Euclide(a,b).</span></p>"}︡
︠391e40a1-5820-4807-b7b9-ba8ce324f6fe︠
def pgcd(a,b):
    deca, decb = Factorisation(a),Factorisation(b)
    pgcd = []
    k1, k2 = 0,0
    while k1<len(deca) and k2<len(decb):
        (x,y) = deca[k1]
        (x2,y2) = decb[k2]
        if x==x2 : 
            pgcd.append((x, min(y,y2)))
            k1 +=1
            k2 +=1
        elif x<x2: k1+=1
        else : k2+=1
    return pgcd
︡8d8ecb62-acab-4471-9155-f13b0854c809︡︡
︠65dca3b6-d8b2-47a7-a938-511fc0cba6b6︠
def evaluate (l):
    if l==[]: return 1
    else: 
        (x,y) = l[0]
        return x**y*evaluate (l[1:])
︡b2a79900-241d-4f04-a629-d986faa4ba14︡︡
︠df2f4597-0546-4b6c-ba8a-95fe20422f66i︠
%html
<p><span style="font-size: small;">Exercice 8 : &Eacute;crivez une fonction IndicatriceEuler(n) qui renvoie &phi;(n), c'est-&agrave;-dire le nombre d'&eacute;l&eacute;ments inversibles de Z/nZ. Utilisez la derni&egrave;re question de l'exercice 3.</span></p>

︡3c9d7aea-8c33-4a17-92ed-67fbdf2b9cea︡{"html": "<p><span style=\"font-size: small;\">Exercice 8 : &Eacute;crivez une fonction IndicatriceEuler(n) qui renvoie &phi;(n), c'est-&agrave;-dire le nombre d'&eacute;l&eacute;ments inversibles de Z/nZ. Utilisez la derni&egrave;re question de l'exercice 3.</span></p>"}︡
︠9532d776-e47b-42ee-9d42-fa97588a38df︠
def IndicatriceEuler(n):
    phi = 0
    for i in range(n):
        (x,y) = Inversible(i,n)
        if x==1: phi+=1
    return phi
        
IndicatriceEuler(7)
︡33481e87-45d9-4b7d-870c-9ca64c69b104︡{"stdout": "6"}︡
︠fddcea1c-9736-4768-9f7e-c03959344896i︠
%html
<p><span style="font-size: small;">Exercice bonus  (*) : &Eacute;crivez une fonction Reste(a,b,n) qui prend en entr&eacute;e un entier a,  un entier b (tr&egrave;s grand) et un entier n&gt;1, et qui calcule le reste  de a^b&nbsp; modulo n, le plus vite possible. Notamment, &eacute;viter de multiplier  par a b fois. Indice : observer la p&eacute;riodicit&eacute; et utiliser la division  euclidienne.</span></p>

︡dffddfbd-dad5-4398-8e55-8d9c5819f7ab︡{"html": "<p><span style=\"font-size: small;\">Exercice bonus  (*) : &Eacute;crivez une fonction Reste(a,b,n) qui prend en entr&eacute;e un entier a,  un entier b (tr&egrave;s grand) et un entier n&gt;1, et qui calcule le reste  de a^b&nbsp; modulo n, le plus vite possible. Notamment, &eacute;viter de multiplier  par a b fois. Indice : observer la p&eacute;riodicit&eacute; et utiliser la division  euclidienne.</span></p>"}︡
︠6fa8a04d-9cb6-4b36-923a-3d8c9a0af41a︠
def Reste(a,b,n):
    reste = a%n
    puissance = 1
    table = [0]*n
    while table[reste]==0:
        table[reste]=puissance
        reste = reste*a%n
        puissance +=1
    preperiode = table[reste]
    periode = puissance-table[reste]
    (q,r) = DivEucl(b-preperiode, periode)
    return (reste*(a**r))%n
︡5d7fdabc-d4fc-4d84-84b3-1f56bf4fa9f5︡︡
︠440ce394-0c73-408f-9e21-0220b5cf1387︠
Reste(2,134234,5)
︡787dc063-57c0-4cef-82ed-11aea7fe77d8︡{"stdout": "4"}︡
︠6c85f65f-7d3e-4912-99fb-3dd4417c055di︠
%html
<p><span style="font-size: small;">Exercice bonus 2 (*) : &Eacute;crire une fonction Diviseurs(a) qui renvoie la liste des diviseurs de a (sans tester tous les entiers &lt;a !). Utilisez la factorisation en facteurs premiers.</span></p>

︡b02fb0a6-5993-479e-b35f-012b9b623fad︡{"html": "<p><span style=\"font-size: small;\">Exercice bonus 2 (*) : &Eacute;crire une fonction Diviseurs(a) qui renvoie la liste des diviseurs de a (sans tester tous les entiers &lt;a !). Utilisez la factorisation en facteurs premiers.</span></p>"}︡
︠0b18ce40-2379-4f6b-a015-45c69bbeb12c︠
def Diviseurs(a):
    div = Factorisation(a)
    actuel = []
    for (x,y) in div : actuel.append((x,0))
    reponse=[]
    finished = True
    while finished :
        k = 0
        finished = False
        while k<len(div) and not finished:
            (x,y),(x1,y1) = div[k], actuel[k]
            if y > y1: 
                actuel[k]=(x1,y1+1)
                finished = True
            else :
                actuel[k]=(x1,0)
                k+=1
        reponse.append(evaluate(actuel))    
    return reponse
    
    Diviseurs(60)
︡fd6c7640-aafb-452e-bc09-5e74afa60ebf︡︡
︠ec917753-4021-49d8-8e31-e0d2c041e2fei︠
%html
<p><span style="font-size: small;"><br /></span></p>

︡3e50c6de-57de-4a0f-aa93-ab912c936e22︡{"html": "<p><span style=\"font-size: small;\"><br /></span></p>"}︡
